(() => {
    let a = {
        videoSubtitle: function(s = "video-subtitle") {
            const l = [ {
                id: 1,
                name: "YouTube",
                matches: "www.youtube.com"
            }, {
                id: 2,
                name: "TED",
                matches: "www.ted.com"
            }, {
                id: 3,
                name: "Vimeo",
                matches: "vimeo.com"
            }, {
                id: 4,
                name: "NetFlix",
                matches: "www.netflix.com"
            }, {
                id: 5,
                name: "Bilibili",
                matches: "www.bilibili.com"
            }, {
                id: 6,
                name: "IQIYI",
                matches: "www.iq.com"
            }, {
                id: 7,
                name: "YOUKU",
                matches: "www.youku.tv"
            }, {
                id: 8,
                name: "Youtube Kids",
                matches: "www.youtubekids.com"
            }, {
                id: 9,
                name: "Viu",
                matches: "www.viu.com"
            }, {
                id: 10,
                name: "Domestika",
                matches: "www.domestika.org"
            }, {
                id: 11,
                name: "Khan Academy",
                matches: "www.khanacademy.org"
            }, {
                id: 12,
                name: "ARD Mediathek",
                matches: "www.ardmediathek."
            }, {
                id: 13,
                name: "ZDF",
                matches: "www.zdf.de"
            }, {
                id: 14,
                name: "WeTV iflix",
                matches: "www.iflix.com"
            } ];
            function r() {
                return new Array(4).fill(null).map(() => Math.random().toString(16).slice(-8)).join("");
            }
            function c(e, t, i, a, n, o) {
                window.postMessage({
                    id: e,
                    from: t,
                    to: i,
                    action: a,
                    data: n
                });
                if (typeof o === "function") {
                    function s({
                        data: t
                    }) {
                        if (t.id === e && t.action === `${a}_callback`) {
                            window.removeEventListener("message", s);
                            o(t);
                        }
                    }
                    window.addEventListener("message", s);
                }
            }
            function u() {
                return new Promise((n, t) => {
                    chrome.storage.local.get([ "websiteConfig", "subtitleTranslationConfig" ]).then(i => {
                        let t = i.websiteConfig[location.hostname] || i.websiteConfig["default"];
                        let e = t.targetLanguage === "auto" ? lang.format(chrome.i18n.getUILanguage()) : t.targetLanguage;
                        let a = i.subtitleTranslationConfig;
                        if (i.subtitleTranslationConfig.customWebsite) {
                            let t = Object.keys(i.subtitleTranslationConfig.customWebsite).find(t => new RegExp(t).test(location.href));
                            let e = i.subtitleTranslationConfig.customWebsite[t];
                            Object.assign(a, e);
                        }
                        n({
                            subtitleEnabled: a.enabled,
                            subtitleShowMode: a.showMode,
                            subtitlePosition: a.position,
                            toLanguage: e
                        });
                    });
                });
            }
            function t() {
                window.addEventListener("message", async ({
                    data: o
                }) => {
                    if (o.to !== s) return;
                    switch (o.action) {
                      case "getConfig":
                        u().then(e => {
                            const i = l.find(t => new RegExp(t.matches).test(location.href.split("?")[0]));
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                extensionConfig: e,
                                moduleConfig: i
                            });
                            chrome.storage.local.onChanged.addListener(() => {
                                u().then(t => {
                                    if (JSON.stringify(e) !== JSON.stringify(t)) c(r(), s, "video-subtitle-inject", "updateConfig", {
                                        extensionConfig: t,
                                        moduleConfig: i
                                    });
                                    e = t;
                                });
                            });
                        });
                        break;

                      case "translate_subtitles":
                        const {
                            baseUrl: t
                        } = await chrome.storage.local.get("baseUrl");
                        const e = await chrome.runtime.sendMessage({
                            action: "getLoginInfo"
                        });
                        if (!e || !e.id) {
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                code: 401,
                                msg: chrome.i18n.getMessage("subtitles_login"),
                                url: chrome.runtime.getURL("popup/login.html"),
                                subtitles: o.data.subtitleArr,
                                translateSubtitles: null
                            });
                            return;
                        }
                        if (Date.now() >= new Date(e.subscriptionExpiryDate)) {
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                code: 402,
                                msg: chrome.i18n.getMessage("subtitles_subscribe"),
                                url: `${t}/subscribe`,
                                subtitles: o.data.subtitleArr,
                                translateSubtitles: null
                            });
                            return;
                        }
                        if (o.data.fromLang === "auto") o.data.fromLang = detectLanguage(o.data.subtitleArr.toString()).find(t => lang.format(t.language))?.language || "en";
                        if (o.data.fromLang === o.data.toLang) {
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                code: 500,
                                subtitles: o.data.subtitleArr,
                                translateSubtitles: null
                            });
                            return;
                        }
                        const i = [];
                        const a = 30;
                        const n = o.data.subtitleArr;
                        for (let t = 0; t < n.length; t += a) i.push(n.slice(t, t + a));
                        Promise.all(i.map(n => {
                            return new Promise((i, a) => {
                                chrome.runtime.sendMessage({
                                    action: "translateText",
                                    data: {
                                        server: "microsoft_4191bebefb",
                                        textArr: n,
                                        options: {
                                            from: o.data.fromLang,
                                            to: o.data.toLang
                                        }
                                    }
                                }).then(t => {
                                    const e = t.data;
                                    if (Array.isArray(e) && e.length === n.length) i(e); else a();
                                });
                            });
                        })).then(t => {
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                code: 200,
                                subtitles: n,
                                translateSubtitles: t.flat()
                            });
                        }).catch(t => {
                            c(o.id, s, "video-subtitle-inject", `${o.action}_callback`, {
                                code: 500,
                                subtitles: n,
                                translateSubtitles: null
                            });
                        });
                        break;

                      default:
                        break;
                    }
                });
            }
            return {
                getSupported: function() {
                    return l.find(t => new RegExp(t.matches).test(location.href.split("?")[0]));
                },
                isSupported: function() {
                    return this.getSupported() !== undefined;
                },
                inject: function() {
                    if (!this.isSupported()) return;
                    t();
                    document.addEventListener("readystatechange", t => {
                        if (t.target.readyState === "interactive") {
                            const e = document.createElement("script");
                            e.src = chrome.runtime.getURL("lib/subtitlesInject.js");
                            e.toggleAttribute("subtitles-inject", true);
                            document.head.appendChild(e);
                        }
                    });
                }
            };
        }()
    }.videoSubtitle;
    chrome.runtime.onMessage.addListener((t, e, i) => {
        "getSubtitleInfo" === t.action && i({
            isSupported: a.isSupported(),
            subtitleInfo: a.getSupported()
        });
    }), a.inject();
})(globalThis);