((r = "video-subtitle-inject") => {
    let l = {
        hookXHR(t, e) {
            let i = XMLHttpRequest.prototype.open, s = XMLHttpRequest.prototype.send;
            Object.defineProperty(XMLHttpRequest.prototype, "open", {
                value: function() {
                    return this._url = arguments[1], i.apply(this, arguments);
                },
                writable: !0
            }), Object.defineProperty(XMLHttpRequest.prototype, "send", {
                value: async function() {
                    return t.test(this._url) && "function" == typeof e && await Promise.all([ e(this) ]), 
                    s.apply(this, arguments);
                },
                writable: !0
            });
        },
        hookFetch(s, o) {
            let n = window.fetch;
            window.fetch = async function(t, e) {
                let i = "string" == typeof t ? t : t.url || t.href;
                return n(t, e).then(async t => (s.test(i) && "function" == typeof o && await Promise.all([ o(t) ]), 
                t));
            };
        },
        generateId() {
            return new Array(4).fill(null).map(() => Math.random().toString(16).slice(-8)).join("");
        },
        sendMessage(i, t, e, s, o, n) {
            window.postMessage({
                id: i,
                from: t,
                to: e,
                action: s,
                data: o
            }), "function" == typeof n && window.addEventListener("message", function t({
                data: e
            }) {
                e.id === i && e.action === s + "_callback" && (window.removeEventListener("message", t), 
                n(e));
            });
        }
    };
    class e {
        constructor() {
            var t, e = document.createElement("div"), i = (e.classList = [ "translatebase-custom-subtitles" ], 
            e.style.all = "initial", e.attachShadow({
                mode: "closed"
            })), s = `
                <section>
                    <style>
                        .subtitles-container {
                            position: absolute;
                            top: 0;
                            left: 0;
                            right: 0;
                            bottom: 0;
                            display: flex;
                            justify-content: center;
                            pointer-events: none;
                        }
                        .subtitles-text {
                            position: absolute;
                            bottom: 20px;
                            width: max-content;
                            max-width: 90%;
                            font-size: 16px;
                            font-weight: normal;
                            line-height: 1.5;
                            color: rgb(255, 255, 255);
                            text-align: center;
                            display: flex;
                            flex-direction: column;
                            align-items: center;
                            justify-content: center;
                            pointer-events: auto;
                            cursor: default;
                        }
                        .sText, .tText {
                            width: fit-content;
                            padding: 0 12px;
                            box-sizing: border-box;
                            border-radius: 2px;
                            background-color: rgba(0, 0, 0, 0.5);
                        }
                        .subtitles-container.outside {
                            position: relative;
                            min-height: 60px;
                            padding: 12px 0;
                        }
                        .subtitles-container.outside .subtitles-text {
                            position: relative;
                            bottom: 0;
                        }
                        .subtitles-container.monolingual .sText {
                            display: none;
                        }
                    </style>
                    <div class="subtitles-container">
                        <div class="subtitles-text">
                            <span class="sText"></span>
                            <span class="tText"></span>
                        </div>
                    </div>
                </section>
            `;
            let o = null;
            o = window.trustedTypes && trustedTypes.createPolicy ? (t = trustedTypes.createPolicy("parseSafeHTMLPolicy", {
                createHTML: t => t
            }), new DOMParser().parseFromString(t.createHTML(s), "text/html")) : new DOMParser().parseFromString(s, "text/html"), 
            i.appendChild(o.body.firstChild), this.container = e, this.shadowRoot = i, 
            this.observeDomResize();
        }
        updateSubtitlesText(t, e, i = !1) {
            var s;
            i ? (i = new DOMParser().parseFromString(t, "text/html"), s = new DOMParser().parseFromString(e, "text/html"), 
            this.shadowRoot.querySelector(".sText").replaceChildren(...i.body.childNodes), 
            this.shadowRoot.querySelector(".tText").replaceChildren(...s.body.childNodes)) : (this.shadowRoot.querySelector(".sText").innerText = t, 
            this.shadowRoot.querySelector(".tText").innerText = e);
        }
        observeDomResize() {
            new ResizeObserver(t => {
                t = t[0].contentRect.width;
                this.shadowRoot.querySelector(".subtitles-text").style.fontSize = t < 768 ? "15px" : t < 992 ? "16px" : t < 1200 ? "18px" : t < 1920 ? "20px" : "24px";
            }).observe(this.shadowRoot.querySelector(".subtitles-container"));
        }
    }
    class i {
        constructor() {
            this.loginAtFirst = !0, this.subscribeAtFirst = !0;
        }
        showLogin({
            msg: t,
            loginUrl: r
        }, e) {
            var i;
            this.loginAtFirst && (this.loginAtFirst = !1, {
                container: t,
                shadowRoot: i
            } = this.createSimpleDom(t), i.querySelector(".content a").addEventListener("click", t => {
                var {
                    width: e,
                    height: i
                } = screen;
                let s = window.open(r, "_blank", `width=460,height=600, left=${e / 2 - 230}, top=` + (i / 2 - 300)), o = setInterval(() => {
                    s.closed && (clearInterval(o), n?.remove(), location.reload());
                }, 1e3), n = document.createElement("div");
                n.style.cssText = `
                    position: fixed;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    background-color: rgba(0, 0, 0, 0.5);
                    z-index: 9999;
                `, document.body.appendChild(n), n.addEventListener("click", () => {
                    s.focus();
                });
            }), "function" == typeof e ? e(t) : console.log("[TranslationFailDialog] insertToFn is not a function"));
        }
        showSubscribe({
            msg: t,
            subscribeUrl: e
        }, i) {
            var s;
            this.subscribeAtFirst && (this.subscribeAtFirst = !1, {
                container: t,
                shadowRoot: s
            } = this.createSimpleDom(t), s.querySelector(".content a").addEventListener("click", t => {
                window.open(e);
            }), "function" == typeof i ? i(t) : console.log("[TranslationFailDialog] insertToFn is not a function"));
        }
        createSimpleDom(t) {
            t = `
                <section>
                    <style>
                        .notice-container {
                            position: absolute;
                            top: 50px;
                            left: 0;
                            z-index: 9999;
                            width: 100%;
                            display: flex;
                            pointer-events: none;
                        }
                        .notice-wrapper {
                            position: relative;
                            max-width: 80%;
                            min-width: 200px;
                            margin: 0 auto;
                            padding: 6px;
                            border-radius: 2px;
                            background-color: rgba(0, 0, 0, 0.85);
                            font-size: 15px;
                            color: #fff;
                            line-height: 24px;
                            display: flex;
                            justify-content: space-between;
                            align-items: center;
                            gap: 20px;
                            pointer-events: auto;
                            cursor: default;
                        }
                        .close {
                            width: 24px;
                            height: 24px;
                            font-size: 18px;
                            text-align: center;
                            cursor: pointer;
                        }
                        .content {
                            position: relative;
                            display: flex;
                            justify-content: center;
                            align-items: center;
                        }
                        .content a {
                            padding: 0 2px;
                            color: #00aeec;
                            text-decoration: underline;
                            cursor: pointer;
                        }
                    </style>
                    <div class="notice-container">
                        <div class="notice-wrapper">
                            <div class="content">${t}</div>
                            <div class="close">×</div>
                        </div>
                    </div>
                </section>
            `;
            let e = document.createElement("div");
            e.classList.add("translatebase-notice"), e.style.all = "initial", e.addEventListener("click", t => t.stopPropagation());
            var i, s = e.attachShadow({
                mode: "closed"
            });
            let o = null;
            return o = window.trustedTypes && trustedTypes.createPolicy ? (i = trustedTypes.createPolicy("parseSafeHTMLPolicy", {
                createHTML: t => t
            }), new DOMParser().parseFromString(i.createHTML(t), "text/html")) : new DOMParser().parseFromString(t, "text/html"), 
            s.appendChild(o.body.firstChild), s.querySelector(".close").addEventListener("click", t => {
                e.remove();
            }), {
                container: e,
                shadowRoot: s
            };
        }
    }
    class t {
        constructor(t) {
            this.extensionConfig = t.extensionConfig, this.moduleConfig = t.moduleConfig, 
            this.customSubtitle = new e(), this.transitionFailDialog = new i();
        }
        updateConfig(t) {
            let e, i, s, o, n = t.extensionConfig;
            Object.keys(n).forEach(t => {
                this.extensionConfig.hasOwnProperty(t) && this.extensionConfig[t] !== n[t] && (this.extensionConfig[t] = n[t], 
                "subtitleEnabled" === t && (e = !0), "subtitleShowMode" === t && (i = !0), 
                "subtitlePosition" === t && (s = !0), "toLanguage" === t) && (o = !0);
            });
            try {
                i && this.toggleSubtitleShowMode(), s && this.toggleSubtitlePosition(), 
                e ? this.extensionConfig.subtitleEnabled ? this.enable() : this.disable() : o && this.extensionConfig.subtitleEnabled && this.reTranslate();
            } catch (t) {
                console.warn("[Extension] " + t);
            }
        }
        enable() {
            location.reload();
        }
        disable() {
            location.reload();
        }
        reTranslate() {
            location.reload();
        }
        toggleSubtitleShowMode() {
            var t = "monolingual" === this.extensionConfig.subtitleShowMode;
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").classList.toggle("monolingual", t);
        }
        toggleSubtitlePosition() {
            var t = "outside" === this.extensionConfig.subtitlePosition;
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").classList.toggle("outside", t);
        }
        translateSubtitles(s, o, n) {
            return new Promise((e, t) => {
                var i = l.generateId();
                l.sendMessage(i, r, "video-subtitle", "translate_subtitles", {
                    subtitleArr: s,
                    fromLang: o || "auto",
                    toLang: n
                }, t => {
                    200 === t.data.code ? e(t.data.translateSubtitles) : (401 === t.data.code && this.transitionFailDialog.showLogin({
                        msg: t.data.msg,
                        loginUrl: t.data.url
                    }, t => this.noticeInsertTo(t, "login")), 402 === t.data.code && this.transitionFailDialog.showSubscribe({
                        msg: t.data.msg,
                        subscribeUrl: t.data.url
                    }, t => this.noticeInsertTo(t, "subscribe")), e([]));
                });
            });
        }
        noticeInsertTo(t, e) {}
    }
    class s extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                ("outside" === this.extensionConfig.subtitlePosition ? this.player.closest("#player") : this.player).appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookXHR(new RegExp("/api/timedtext?"), e => {
                this.subtitlePromise = new Promise((i, t) => {
                    let s = new URL(e._url);
                    s.searchParams.delete("fmt"), fetch(s).then(t => t.text()).then(t => {
                        var e = trustedTypes.createPolicy("sanitizer", {
                            createHTML: t => t.replaceAll("&amp;#39;", "'")
                        }), e = new DOMParser().parseFromString(e.createHTML(t), "text/xml").getElementsByTagName("text"), t = Array.from(e).reduce((t, e) => {
                            var i = Number(e.getAttribute("start")), s = i + Number(e.getAttribute("dur")), e = e.textContent, o = t[t.length - 1];
                            return o && o.end > i ? o.content += " " + e : t.push({
                                start: i,
                                end: s,
                                content: e,
                                translationContent: ""
                            }), t;
                        }, []);
                        i({
                            lang: s.searchParams.get("tlang") || s.searchParams.get("lang"),
                            isTranslated: !1,
                            subtitles: t
                        });
                    }).catch(() => {
                        t("Faild to fetch subtitles");
                    });
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector("#movie_player") && (clearInterval(i), 
                    this.player = document.querySelector("#movie_player"), this.playerListener = this.registerPlayerListener(), 
                    "true" === this.player.querySelector(".ytp-subtitles-button")?.getAttribute("aria-pressed") && (this.player.querySelector(".ytp-subtitles-button").click(), 
                    setTimeout(() => {
                        this.player.querySelector(".ytp-subtitles-button").click();
                    }, 200)), t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                "true" !== s.player.querySelector(".ytp-subtitles-button").getAttribute("aria-pressed") ? s.customSubtitle.updateSubtitlesText("", "") : s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "");
                }).catch(() => {
                    s.customSubtitle.updateSubtitlesText("", "");
                });
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                .ytp-caption-window-container {
                    display: none;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 10px;
                    --subtitles-container-transition: bottom 0.25s;
                }
                .html5-video-player:not(.ytp-autohide) .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 60px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.zIndex = "99", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.transition = "var(--subtitles-container-transition)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("#movie_player video").parentElement.querySelector(".translatebase-notice") || document.querySelector("#movie_player video").after(t);
            }
        }
    }
    class o extends t {
        constructor(t) {
            var e = new URLSearchParams(location.search);
            e.get("subtitle") ? (e.delete("subtitle"), history.replaceState({}, "", [ location.pathname, e.toString() ].filter(Boolean).join("?")), 
            location.reload()) : (super(t), this.subtitlePromise = null, this.playerPromise = null, 
            this.player = null, this.playerListener = null, this.hookSubtitlesRequest(), 
            this.hookPlayerMount(), this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable());
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                ("outside" === this.extensionConfig.subtitlePosition ? this.player.parentElement : this.player).appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookFetch(new RegExp("full.vtt"), t => {
                let l = new URLSearchParams(location.search).get("subtitle");
                l && new RegExp(`/subtitles/${l}/full.vtt?`).test(t.url) && (this.subtitlePromise = new Promise((r, e) => {
                    let i = new XMLHttpRequest();
                    i.open("GET", t.url, !0), i.responseType = "blob", i.onload = function() {
                        var t;
                        200 === i.status ? ((t = new FileReader()).onload = function(t) {
                            var e = t.target.result.trim().split("\n"), i = [];
                            let s = 0;
                            for (;s < e.length; ) {
                                var o = /^(\d{2}):(\d{2}):(\d{2})\.(\d{3}) --> (\d{2}):(\d{2}):(\d{2})\.(\d{3})/, n = e[s].trim().match(o);
                                if (n) {
                                    s++;
                                    let t = "";
                                    for (;s < e.length && !e[s].match(o); ) t += e[s].trim() + "\n", 
                                    s++;
                                    i.push({
                                        start: 3600 * n[1] + 60 * n[2] + +n[3] + n[4] / 1e3,
                                        end: 3600 * n[5] + 60 * n[6] + +n[7] + n[8] / 1e3,
                                        content: t.trim(),
                                        translationContent: ""
                                    });
                                } else s++;
                            }
                            r({
                                lang: l,
                                isTranslated: !1,
                                subtitles: i
                            });
                        }, t.readAsText(i.response)) : e("Failed to fetch subtitles");
                    }, i.send(), this.hookPlayerMount(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
                }));
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector("media-controller") && (clearInterval(i), 
                    this.player = document.querySelector("media-controller"), this.playerListener = this.registerPlayerListener(), 
                    t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let o = this;
            function t() {
                o.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                new URLSearchParams(location.search).get("subtitle") ? o.subtitlePromise?.then(i => {
                    let e = Number(o.player.querySelector("#media-control-bar .video-player-range-input").getAttribute("value"));
                    var t, s = i.subtitles.find(t => t.start <= e && t.end > e);
                    s.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    o.translateSubtitles(t, i.lang || "auto", o.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), o.customSubtitle.updateSubtitlesText(s.content, s.translationContent || "");
                }).catch(() => {
                    o.customSubtitle.updateSubtitlesText("", "");
                }) : o.customSubtitle.updateSubtitlesText("", "");
            }
            return {
                on: function() {
                    o.player.querySelector("video").addEventListener("loadstart", t), 
                    o.player.querySelector("video").addEventListener("timeupdate", e), 
                    o.toggleSubtitlePosition(), o.toggleSubtitleShowMode();
                },
                off: function() {
                    o.player.querySelector("video").removeEventListener("loadstart", t), 
                    o.player.querySelector("video").removeEventListener("timeupdate", e), 
                    o.toggleSubtitlePosition(), o.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                media-controller .transition-transform {
                    display: none;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 24px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("media-controller video").parentElement.querySelector(".translatebase-notice") || document.querySelector("media-controller video").after(t);
            }
        }
    }
    class n extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookPlayerMount(), this.hookSubtitlesChange(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                "outside" === this.extensionConfig.subtitlePosition ? (document.querySelector(".chakra-stack").before(this.customSubtitle.container), 
                document.querySelector(".chakra-stack").parentElement.style.gridTemplateAreas = `
                            "media media media media media media"
                            "outsideSubtitles outsideSubtitles outsideSubtitles outsideSubtitles outsideSubtitles outsideSubtitles"
                            "contentStack contentStack contentStack contentStack comments comments"
                            "playlist playlist playlist playlist comments comments"
                        `) : (this.player.querySelector(".vp-player-ui-overlays").after(this.customSubtitle.container), 
                document.querySelector(".chakra-stack").parentElement.style.gridTemplateAreas = `
                            "media media media media media media"
                            "contentStack contentStack contentStack contentStack comments comments"
                            "playlist playlist playlist playlist comments comments"
                        `);
            })) : (this.customSubtitle.container.remove(), document.querySelector(".chakra-stack").parentElement.style.gridTemplateAreas = `
                    "media media media media media media"
                    "contentStack contentStack contentStack contentStack comments comments"
                    "playlist playlist playlist playlist comments comments"
                `);
        }
        hookSubtitlesChange() {
            this.playerPromise.then(() => {
                let t = this, o = t.player.querySelector("video");
                function e() {
                    t.subtitlePromise = new Promise((e, t) => {
                        let i = Array.from(o.textTracks).find(t => "disabled" !== t.mode);
                        if (!i) return t("No active track");
                        let s = setInterval(() => {
                            var t;
                            0 < i.cues.length && (clearInterval(s), t = Array.from(i.cues).map(t => ({
                                start: t.startTime,
                                end: t.endTime,
                                content: t.text,
                                translationContent: ""
                            })), e({
                                lang: i.language?.split("-")[0],
                                isTranslated: !1,
                                subtitles: t
                            }));
                        }, 100);
                    });
                }
                e(), o.textTracks.addEventListener("change", t => {
                    e();
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector(".player video") && (clearInterval(i), 
                    this.player = document.querySelector(".player"), this.playerListener = this.registerPlayerListener(), 
                    t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "", !0);
                }).catch(t => {
                    s.customSubtitle.updateSubtitlesText("", "");
                });
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                .translatebase-custom-subtitles {
                    grid-area: outsideSubtitles !important;
                }
                .player .vp-player-ui-overlays .vp-captions {
                    display: none;
                }
                .player .translatebase-custom-subtitles,
                .player.player-cursor-hide .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 0;
                    --subtitles-container-transition: bottom .25s ease-out .2s;
                }
                .player:not([tabindex]) .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 50px;
                    --subtitles-container-transition: bottom .15s ease;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.transition = "var(--subtitles-container-transition)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".player video").parentElement.querySelector(".translatebase-notice") || document.querySelector(".player video").after(t);
            }
        }
    }
    class a extends t {
        constructor(t) {
            super(t), this.hookSubtitlesRequest();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] NetFlixTranslator 不支持字幕显示位置切换");
        }
        hookSubtitlesRequest() {
            this.extensionConfig.subtitleEnabled && l.hookXHR(new RegExp("^https://.+?.oca.nflxvideo.net/\\?([ovet]=[^=]+){4}$"), o => new Promise((i, t) => {
                fetch(o._url).then(async t => {
                    t = await t.text();
                    if (t) {
                        var e = new DOMParser().parseFromString(t, "text/xml");
                        let i = Array.from(e.querySelectorAll("p")).map(t => t.textContent), s = await this.translateSubtitles(i, "auto", this.extensionConfig.toLanguage);
                        Array.from(e.querySelectorAll("p")).forEach((t, e) => {
                            "bilingual" === this.extensionConfig.subtitleShowMode ? (t.textContent = i[e], 
                            t.appendChild(document.createElement("br")), t.appendChild(document.createTextNode(s[e]))) : t.textContent = s[e];
                        }), t = new XMLSerializer().serializeToString(e), Object.defineProperty(o, "responseText", {
                            value: t,
                            writable: !1
                        }), Object.defineProperty(o, "response", {
                            value: t,
                            writable: !1
                        });
                    } else console.log("[Extension] NetFlixTranslator hookSubtitlesRequest error: xml is empty");
                    i();
                }).catch(t => {
                    console.log("[Extension] NetFlixTranslator hookSubtitlesRequest error: " + t), 
                    i();
                });
            }));
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".watch-video").parentElement.querySelector(".translatebase-notice") || document.querySelector(".watch-video").after(t);
            }
        }
    }
    class u extends t {
        constructor(t) {
            super(t), this.hookSubtitlesRequest();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] BilibiliTranslator 不支持字幕显示位置切换");
        }
        hookSubtitlesRequest() {
            this.extensionConfig.subtitleEnabled && l.hookXHR(new RegExp("aisubtitle.hdslb.com/bfs/"), o => new Promise((s, t) => {
                fetch(o._url).then(async t => {
                    var t = await t.json(), e = t.body.map(t => t.content);
                    let i = await this.translateSubtitles(e, t.lang, this.extensionConfig.toLanguage);
                    t.body.forEach((t, e) => {
                        "bilingual" === this.extensionConfig.subtitleShowMode ? t.content += `
` + i[e] : t.content = i[e];
                    }), Object.defineProperty(o, "responseText", {
                        value: t,
                        writable: !1
                    }), Object.defineProperty(o, "response", {
                        value: t,
                        writable: !1
                    }), s();
                }).catch(t => {
                    console.log("[Extension] BilibiliTranslator hookSubtitlesRequest error: " + t), 
                    s();
                });
            }));
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("#bilibili-player video").parentElement.querySelector(".translatebase-notice") || document.querySelector("#bilibili-player video").after(t);
            }
        }
    }
    class c extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                ("outside" === this.extensionConfig.subtitlePosition ? this.player.closest(".intl-play-left") : this.player).appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookXHR(new RegExp(".xml?"), t => {
                this.subtitlePromise = new Promise((e, i) => {
                    fetch(t._url).then(t => t.text()).then(t => {
                        t = new DOMParser().parseFromString(t, "text/xml"), t = Array.from(t.querySelectorAll("dia")).map(t => ({
                            start: t.querySelector("st").textContent / 1e3,
                            end: t.querySelector("et").textContent / 1e3,
                            content: t.querySelector("sub").textContent,
                            translationContent: ""
                        }));
                        e({
                            isTranslated: !1,
                            subtitles: t
                        });
                    }).catch(t => {
                        i(t);
                    });
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector(".iqp-player") && (clearInterval(i), 
                    this.player = document.querySelector(".iqp-player"), this.playerListener = this.registerPlayerListener(), 
                    t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                var t = s.player.querySelector(".iqp-btn-subtitle .iqp-langlist-pop-txt.selected");
                t && "close" !== t.getAttribute("datakey") ? s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translateSubtitle = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translateSubtitle || "");
                }).catch(t => {
                    s.customSubtitle.updateSubtitlesText("", "");
                }) : s.customSubtitle.updateSubtitlesText("", "");
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                .iqp-subtitle {
                    z-index: -1 !important;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 30px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".iqp-player video").parentElement.querySelector(".translatebase-notice") || document.querySelector(".iqp-player video").after(t);
            }
        }
    }
    class d extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                ("outside" === this.extensionConfig.subtitlePosition ? this.player.closest(".play-paction-wrap-new") : this.player).appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookFetch(new RegExp("\\.ass$"), t => {
                this.subtitlePromise = new Promise((u, e) => {
                    let i = new XMLHttpRequest();
                    i.open("GET", t.url, !0), i.responseType = "blob", i.onload = function() {
                        var t;
                        200 === i.status ? ((t = new FileReader()).onload = function(t) {
                            t = t.target.result;
                            let e = new TextDecoder("utf-8").decode(t);
                            var i = e.trim().split("\n"), s = [];
                            let o = 0;
                            for (;o < i.length; ) {
                                var n = i[o].trim();
                                if (n.startsWith("Dialogue:")) {
                                    var r = /Dialogue:([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),(.*)/, l = /(\d+):(\d+):(\d+)\.(\d+)/, a = n.match(r)[2].match(l), l = n.match(r)[3].match(l);
                                    let t = n.match(r)[10];
                                    s.push({
                                        start: 3600 * a[1] + 60 * a[2] + +a[3] + a[4] / 1e3,
                                        end: 3600 * l[1] + 60 * l[2] + +l[3] + l[4] / 1e3,
                                        content: t.trim(),
                                        translationContent: ""
                                    });
                                }
                                o++;
                            }
                            u({
                                isTranslated: !1,
                                subtitles: s
                            });
                        }, t.readAsArrayBuffer(i.response)) : e("Failed to fetch subtitles");
                    }, i.send();
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector("#ykPlayer video") && (clearInterval(i), 
                    this.player = document.querySelector("#ykPlayer"), this.playerListener = this.registerPlayerListener(), 
                    t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                videoPlayer.context.mediaData.subtitleSwitch ? s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "");
                }).catch(() => {
                    s.customSubtitle.updateSubtitlesText("", "");
                }) : s.customSubtitle.updateSubtitlesText("", "");
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                #subtitle {
                    display: none !important;
                }
                .play-top-container-new {
                    --video-bottom-height: 60px;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 60px;
                    --video-bottom-height: 60px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("#ykPlayer .translatebase-notice") || document.querySelector("#ykPlayer").appendChild(t);
            }
        }
    }
    class b extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                "outside" === this.extensionConfig.subtitlePosition ? (this.player.closest("ytk-player").appendChild(this.customSubtitle.container), 
                this.player.closest("#player-container-inner").toggleAttribute("resetH", !0)) : (this.player.appendChild(this.customSubtitle.container), 
                this.player.closest("#player-container-inner").toggleAttribute("resetH", !1));
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookXHR(new RegExp("/api/timedtext?"), e => {
                this.subtitlePromise = new Promise((i, t) => {
                    let s = new URL(e._url);
                    s.searchParams.delete("fmt"), fetch(s).then(t => t.text()).then(t => {
                        var e = trustedTypes.createPolicy("sanitizer", {
                            createHTML: t => t.replaceAll("&amp;#39;", "'")
                        }), e = new DOMParser().parseFromString(e.createHTML(t), "text/xml").getElementsByTagName("text"), t = Array.from(e).reduce((t, e) => {
                            var i = Number(e.getAttribute("start")), s = i + Number(e.getAttribute("dur")), e = e.textContent, o = t[t.length - 1];
                            return o && o.end > i ? o.content += " " + e : t.push({
                                start: i,
                                end: s,
                                content: e,
                                translationContent: ""
                            }), t;
                        }, []);
                        i({
                            lang: s.searchParams.get("tlang") || s.searchParams.get("lang"),
                            isTranslated: !1,
                            subtitles: t
                        });
                    }).catch(() => {
                        t("Faild to fetch subtitles");
                    });
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector("#movie_player") && (clearInterval(i), 
                    this.player = document.querySelector("#movie_player"), this.playerListener = this.registerPlayerListener(), 
                    "true" === document.querySelector("#cc-button")?.getAttribute("aria-pressed") && (document.querySelector("#cc-button").click(), 
                    setTimeout(() => {
                        document.querySelector("#cc-button").click();
                    }, 200)), t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                "true" !== document.querySelector("#cc-button").getAttribute("aria-pressed") ? s.customSubtitle.updateSubtitlesText("", "") : s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "");
                }).catch(() => {
                    s.customSubtitle.updateSubtitlesText("", "");
                });
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                .ytp-caption-window-container {
                    display: none;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 12px;
                    --subtitles-container-transition: bottom 0.25s;
                }
                ytk-player[show-controls] .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 90px;
                }
                #player-container-inner[resetH] #player-container {
                    height: calc(100vh - 375px);
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.zIndex = "99", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.transition = "var(--subtitles-container-transition)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("#movie_player video").parentElement.querySelector(".translatebase-notice") || document.querySelector("#movie_player video").after(t);
            }
        }
    }
    class h extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                "outside" === this.extensionConfig.subtitlePosition ? document.querySelector("#vodDetail").before(this.customSubtitle.container) : this.player.parentElement.appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookXHR(new RegExp("https?://ott-resources.viu.com/"), e => {
                this.subtitlePromise = new Promise((n, t) => {
                    fetch(e._url).then(t => t.text()).then(t => {
                        var e = t.trim().split("\n"), i = [];
                        let s = 0;
                        for (;s < e.length; ) {
                            var o = e[s].trim().match(/^(\d{2}):(\d{2}):(\d{2})\,(\d{3}) --> (\d{2}):(\d{2}):(\d{2})\,(\d{3})/);
                            if (o) {
                                s++;
                                let t = "";
                                for (;s < e.length && e[s].trim(); ) t += e[s].trim() + "\n", 
                                s++;
                                i.push({
                                    start: 3600 * o[1] + 60 * o[2] + +o[3] + o[4] / 1e3,
                                    end: 3600 * o[5] + 60 * o[6] + +o[7] + o[8] / 1e3,
                                    content: t.trim(),
                                    translationContent: ""
                                });
                            } else s++;
                        }
                        n({
                            isTranslated: !1,
                            subtitles: i
                        });
                    }).catch(() => {
                        t("Faild to fetch subtitles");
                    });
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector(".bitmovinplayer-container video") && (clearInterval(i), 
                    this.player = document.querySelector(".bitmovinplayer-container video"), 
                    this.playerListener = this.registerPlayerListener(), t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                document.querySelector("#subtitle_language_list .bmpui-ui-selectionlistitem:first-child")?.classList.contains("bmpui-selected") ? s.customSubtitle.updateSubtitlesText("", "") : s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "");
                }).catch(() => {
                    s.customSubtitle.updateSubtitlesText("", "");
                });
            }
            return {
                on: function() {
                    s.player.addEventListener("loadstart", t), s.player.addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.removeEventListener("loadstart", t), s.player.removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                .bmpui-ui-viu-subtitle-overlay {
                    display: none;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 12px;
                    --subtitles-container-transition: bottom 0.25s;
                }
                .bmpui-controls-shown + .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 90px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.zIndex = "99", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)", 
            this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.transition = "var(--subtitles-container-transition)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".bitmovinplayer-container .translatebase-notice") || document.querySelector(".bitmovinplayer-container").appendChild(t);
            }
        }
    }
    class p extends t {
        constructor(t) {
            super(t), this.hookSubtitlesRequest();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] DomestikaTranslator 不支持字幕显示位置切换");
        }
        hookSubtitlesRequest() {
            this.extensionConfig.subtitleEnabled && l.hookXHR(new RegExp(".*subtitles.*\\.vtt"), l => new Promise((r, t) => {
                fetch(l._url).then(t => t.text()).then(async i => {
                    var e = i.trim().split("\n"), s = [];
                    let o = 0;
                    for (;o < e.length; ) if (e[o].trim().match(/^(\d+):(\d+)\.(\d+) -->/)) {
                        o++;
                        let t = "";
                        for (;o < e.length && e[o].trim(); ) t += e[o] + "\n", o++;
                        s.push(t);
                    } else o++;
                    var t = l._url.match(new RegExp(".*subtitles/(.+)/.+.vtt"))[1];
                    let n = await this.translateSubtitles(s, t || "auto", this.extensionConfig.toLanguage);
                    s.forEach((t, e) => {
                        i = "bilingual" === this.extensionConfig.subtitleShowMode ? i.replaceAll(t, t + n[e]) : i.replaceAll(t, n[e] || t);
                    }), i = new TextEncoder().encode(i).buffer, Object.defineProperty(l, "responseText", {
                        value: i,
                        writable: !1
                    }), Object.defineProperty(l, "response", {
                        value: i,
                        writable: !1
                    }), r();
                }).catch(() => {
                    console.log("[Extension] DomestikaTranslator hookSubtitlesRequest error: " + error), 
                    r();
                });
            }));
        }
        noticeInsertTo(e, t) {
            switch (t) {
              case "login":
              case "subscribe":
                document.querySelectorAll("video").forEach(t => {
                    t.parentElement.querySelector(".translatebase-notice") || t.parentElement.appendChild(e);
                });
            }
        }
    }
    class m extends t {
        constructor(t) {
            super(t), this.playerPromise = null, this.player = null, this.extensionConfig.subtitleEnabled && this.hookPlayerMount();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] KhanAcademyTranslator 不支持字幕显示位置切换");
        }
        hookPlayerMount() {
            let i = null, t = setInterval(() => {
                document.querySelector(".ka-video-player-container video") && (clearInterval(t), 
                new MutationObserver((t, e) => {
                    t.forEach(t => {
                        "VIDEO" === t.target.nodeName && i !== t.target && (i = t.target, 
                        this.extractSubtitles(i), i.textTracks.addEventListener("change", t => {
                            this.extractSubtitles(i);
                        }));
                    });
                }).observe(document.body, {
                    attributes: !0,
                    childList: !0,
                    subtree: !0
                }));
            });
        }
        extractSubtitles(t) {
            let o = Array.from(t.textTracks).find(t => "showing" === t.mode);
            if (o) {
                let t = setInterval(() => {
                    if (0 < o.cues.length && (clearInterval(t), !o.isTranslated)) {
                        o.isTranslated = !0;
                        let s = Array.from(o.cues).map(t => t.text.match(/^<c.caption>(.+)<\/c>$/s)[1]);
                        this.translateSubtitles(s, o.language || "auto", this.extensionConfig.toLanguage).then(i => {
                            s.forEach((t, e) => {
                                "bilingual" === this.extensionConfig.subtitleShowMode ? o.cues[e].text = `<c.caption>${s[e]}
${i[e]}</c>` : o.cues[e].text = `<c.caption>${i[e]}</c>`;
                            });
                        }).catch(t => {
                            o.isTranslated = !1;
                        });
                    }
                }, 100);
            }
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".ka-video-player .translatebase-notice") || document.querySelector(".ka-video-player").appendChild(t);
            }
        }
    }
    class y extends t {
        constructor(t) {
            super(t), this.hookSubtitlesRequest();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] ARDMediathekTranslator 不支持字幕显示位置切换");
        }
        hookSubtitlesRequest() {
            let u = this;
            u.extensionConfig.subtitleEnabled && l.hookFetch(new RegExp("subtitle/ebutt"), a => new Promise((s, o) => {
                let l = new XMLHttpRequest();
                l.open("GET", a.url, !0), l.onload = async function() {
                    try {
                        if (200 === l.status) {
                            var e = trustedTypes.createPolicy("sanitizer", {
                                createHTML: t => t
                            });
                            let o = new DOMParser().parseFromString(e.createHTML(l.response), "text/xml");
                            var i = o.getElementsByTagName("tt:body")[0].getElementsByTagName("tt:span");
                            let n = Array.from(i).map(t => t.textContent), r = await u.translateSubtitles(n, "auto", u.extensionConfig.toLanguage), t = (r.length === n.length && Array.from(i).forEach((t, e) => {
                                var i, s;
                                "bilingual" === u.extensionConfig.subtitleShowMode ? ((i = t.cloneNode(!0)).textContent = r[e], 
                                s = o.createElement("tt:br"), t.after(s, i)) : t.textContent = r[e] || n[e];
                            }), a.text);
                            a.text = function() {
                                return t.apply(this, arguments).then(t => new XMLSerializer().serializeToString(o));
                            }, s();
                        } else o("Failed to fetch subtitles");
                    } catch (t) {
                        o("Failed to fetch subtitles");
                    }
                }, l.send();
            }));
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".ardplayer .translatebase-notice") || document.querySelector(".ardplayer video").parentElement.appendChild(t);
            }
        }
    }
    class S extends t {
        constructor(t) {
            super(t), this.hookSubtitlesRequest();
        }
        toggleSubtitleShowMode() {
            this.extensionConfig.subtitleEnabled && location.reload();
        }
        toggleSubtitlePosition() {
            console.log("[Extension] ZDFTranslator 不支持字幕显示位置切换");
        }
        hookSubtitlesRequest() {
            let u = this;
            u.extensionConfig.subtitleEnabled && l.hookFetch(new RegExp("mtt/.*.xml"), a => new Promise((s, o) => {
                let l = new XMLHttpRequest();
                l.open("GET", a.url, !0), l.onload = async function() {
                    try {
                        if (200 === l.status) {
                            var e = trustedTypes.createPolicy("sanitizer", {
                                createHTML: t => t
                            });
                            let o = new DOMParser().parseFromString(e.createHTML(l.response), "text/xml");
                            var i = o.getElementsByTagName("tt:body")[0].getElementsByTagName("tt:span");
                            let n = Array.from(i).map(t => t.textContent), r = await u.translateSubtitles(n, "auto", u.extensionConfig.toLanguage), t = (r.length === n.length && Array.from(i).forEach((t, e) => {
                                var i, s;
                                "bilingual" === u.extensionConfig.subtitleShowMode ? ((i = t.cloneNode(!0)).textContent = r[e], 
                                s = o.createElement("tt:br"), t.after(s, i)) : t.textContent = r[e] || n[e];
                            }), a.text);
                            a.text = function() {
                                return t.apply(this, arguments).then(t => new XMLSerializer().serializeToString(o));
                            }, s();
                        } else o("Failed to fetch subtitles");
                    } catch (t) {
                        o("Failed to fetch subtitles");
                    }
                }, l.send();
            }));
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector(".zdfplayer-video-container .translatebase-notice") || document.querySelector(".zdfplayer-video-container").appendChild(t);
            }
        }
    }
    class g extends t {
        constructor(t) {
            super(t), this.subtitlePromise = null, this.playerPromise = null, this.player = null, 
            this.playerListener = null, this.hookSubtitlesRequest(), this.hookPlayerMount(), 
            this.customSubtitleStyle(), this.extensionConfig.subtitleEnabled ? this.enable() : this.disable();
        }
        enable() {
            this.playerPromise.then(() => {
                this.playerListener.on();
            });
        }
        disable() {
            this.playerPromise.then(() => {
                this.playerListener.off();
            });
        }
        reTranslate() {
            this.subtitlePromise?.then(t => {
                t.subtitles.forEach(t => t.translationContent = ""), t.isTranslated = !1;
            });
        }
        toggleSubtitlePosition() {
            this.extensionConfig.subtitleEnabled ? (super.toggleSubtitlePosition(), 
            this.playerPromise.then(() => {
                "outside" === this.extensionConfig.subtitlePosition ? this.player.after(this.customSubtitle.container) : this.player.appendChild(this.customSubtitle.container);
            })) : this.customSubtitle.container.remove();
        }
        hookSubtitlesRequest() {
            l.hookXHR(new RegExp(".vtt?"), t => {
                this.subtitlePromise = new Promise((n, e) => {
                    fetch(t._url).then(t => t.text()).then(t => {
                        var e = t.trim().split("\n"), i = [];
                        let s = 0;
                        for (;s < e.length; ) {
                            var o = e[s].trim().match(/^(\d{2}):(\d{2}):(\d{2})\.(\d{3}) --> (\d{2}):(\d{2}):(\d{2})\.(\d{3})/);
                            if (o) {
                                s++;
                                let t = "";
                                for (;s < e.length && e[s].trim(); ) t += e[s].trim() + "\n", 
                                s++;
                                i.push({
                                    start: 3600 * o[1] + 60 * o[2] + +o[3] + o[4] / 1e3,
                                    end: 3600 * o[5] + 60 * o[6] + +o[7] + o[8] / 1e3,
                                    content: t.trim(),
                                    translationContent: ""
                                });
                            } else s++;
                        }
                        t = document.querySelector('span[data-role="wetv-player-subtitle-icon"]').innerText.toLocaleLowerCase();
                        n({
                            lang: t,
                            isTranslated: !1,
                            subtitles: i
                        });
                    }).catch(t => {
                        e("Failed to fetch subtitles");
                    });
                });
            });
        }
        hookPlayerMount() {
            this.playerPromise = new Promise((t, e) => {
                let i = setInterval(() => {
                    document.querySelector("#player-wrapper video") && (clearInterval(i), 
                    this.player = document.querySelector("#player-wrapper"), this.playerListener = this.registerPlayerListener(), 
                    t());
                }, 500);
            });
        }
        registerPlayerListener() {
            let s = this;
            function t() {
                s.customSubtitle.updateSubtitlesText("", "");
            }
            function e() {
                "SUBTITLE" === document.querySelector('span[data-role="wetv-player-subtitle-icon"]').innerText ? s.customSubtitle.updateSubtitlesText("", "") : s.subtitlePromise?.then(i => {
                    var t, e = i.subtitles.find(t => t.start <= this.currentTime && t.end > this.currentTime);
                    e.content && !i.isTranslated && (i.isTranslated = !0, t = i.subtitles.map(t => t.content), 
                    s.translateSubtitles(t, i.lang || "auto", s.extensionConfig.toLanguage).then(t => {
                        t.forEach((t, e) => i.subtitles[e].translationContent = t);
                    })), s.customSubtitle.updateSubtitlesText(e.content, e.translationContent || "");
                }).catch(() => {
                    s.customSubtitle.updateSubtitlesText("", "");
                });
            }
            return {
                on: function() {
                    s.player.querySelector("video").addEventListener("loadstart", t), 
                    s.player.querySelector("video").addEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                },
                off: function() {
                    s.player.querySelector("video").removeEventListener("loadstart", t), 
                    s.player.querySelector("video").removeEventListener("timeupdate", e), 
                    s.toggleSubtitlePosition(), s.toggleSubtitleShowMode();
                }
            };
        }
        customSubtitleStyle() {
            var t = document.createElement("style");
            t.appendChild(document.createTextNode(`
                #player-wrapper .text-track {
                    display: none;
                }
                .translatebase-custom-subtitles {
                    --subtitles-container-bottom: 24px;
                }
            `)), this.customSubtitle.container.prepend(t), this.customSubtitle.shadowRoot.querySelector(".subtitles-container").style.bottom = "var(--subtitles-container-bottom)";
        }
        noticeInsertTo(t, e) {
            switch (e) {
              case "login":
              case "subscribe":
                document.querySelector("#player-wrapper .translatebase-notice") || document.querySelector("#player-wrapper").appendChild(t);
            }
        }
    }
    {
        let e = null;
        l.sendMessage(l.generateId(), r, "video-subtitle", "getConfig", null, t => {
            switch (t.data.moduleConfig.name) {
              case "YouTube":
                e = new s(t.data);
                break;

              case "TED":
                e = new o(t.data);
                break;

              case "Vimeo":
                e = new n(t.data);
                break;

              case "NetFlix":
                e = new a(t.data);
                break;

              case "Bilibili":
                e = new u(t.data);
                break;

              case "IQIYI":
                e = new c(t.data);
                break;

              case "YOUKU":
                e = new d(t.data);
                break;

              case "Youtube Kids":
                e = new b(t.data);
                break;

              case "Viu":
                e = new h(t.data);
                break;

              case "Domestika":
                e = new p(t.data);
                break;

              case "Khan Academy":
                e = new m(t.data);
                break;

              case "ARD Mediathek":
                e = new y(t.data);
                break;

              case "ZDF":
                e = new S(t.data);
                break;

              case "WeTV iflix":
                e = new g(t.data);
                break;

              default:
                return;
            }
            window.addEventListener("message", ({
                data: t
            }) => {
                t.to === r && "updateConfig" === t.action && e.updateConfig(t.data);
            });
        });
    }
})();