import extConfig from "/lib/config.js";

(() => {
    let t = lang.getLanguageList(), e = new Promise(t => {
        chrome.runtime.sendMessage({
            action: "getLoginInfo"
        }).then(e => {
            t(e);
        });
    }), s = document.querySelector("#base-template"), a = (s.remove(), customElements.define("base-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(s.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.renderAccountBox(), Promise.all([ chrome.runtime.sendMessage({
                action: "getTranslateServiceList"
            }), chrome.storage.local.get([ "websiteConfig", "translationPlayEnabled" ]) ]).then(([ e, {
                websiteConfig: t,
                translationPlayEnabled: s
            } ]) => {
                this.currentTargetLanguage = t.default.targetLanguage, this.renderTargetLanguage(e.find(e => e.default));
                t = e.reduce((e, t) => {
                    var s;
                    return t.enabled && (s = chrome.i18n.getMessage("translate_engine_" + t.id) || t.name, 
                    e.push(new Option(s, t.id, !1, t.default))), e;
                }, []);
                this.querySelector('select[data-type="translationService"]').append(...t), 
                this.querySelector('select[data-type="translationService"]').addEventListener("change", t => {
                    chrome.storage.local.get("translateServices").then(({
                        translateServices: e
                    }) => {
                        e.forEach(e => e.default = !1), e.find(e => e.id === t.target.value).default = !0, 
                        chrome.storage.local.set({
                            translateServices: e
                        }), this.renderTargetLanguage(e.find(e => e.default));
                    });
                }), this.querySelector('.switch [data-type="translationAudioEnabled"]').checked = s, 
                this.querySelector('.switch [data-type="translationAudioEnabled"]').addEventListener("change", e => {
                    chrome.storage.local.set({
                        translationPlayEnabled: e.target.checked
                    });
                });
            });
        }
        renderTargetLanguage(e) {
            "24093015132425024428" === e.id ? (e = Object.keys(t).filter(e => Boolean(t[e].DeepLLangCode)).map(e => new Option(t[e].name, e, !1, e === this.currentTargetLanguage)), 
            this.querySelector('select[data-type="targetLang"]').replaceChildren(...e)) : (e = Object.keys(t).map(e => new Option(t[e].name, e, !1, e === this.currentTargetLanguage)), 
            this.querySelector('select[data-type="targetLang"]').replaceChildren(...e)), 
            this.querySelector('select[data-type="targetLang"]').addEventListener("change", s => {
                chrome.storage.local.get("websiteConfig").then(({
                    websiteConfig: t
                }) => {
                    Object.keys(t).forEach(e => {
                        t[e].targetLanguage = s.target.value;
                    }), chrome.storage.local.set({
                        websiteConfig: t
                    }), this.currentTargetLanguage = s.target.value;
                });
            }), this.querySelector('select[data-type="targetLang"]').dispatchEvent(new Event("change"));
        }
        renderAccountBox() {
            e.then(async e => {
                var e = e || await chrome.runtime.sendMessage({
                    action: "getLoginInfo"
                });
                e && e.id ? (this.querySelector(".account-box").toggleAttribute("login", !0), 
                this.querySelector(".account-box__left .avatar").src = "" + extConfig.baseUrl + e.headPortrait, 
                this.querySelector(".account-box__left .status").append(e.email), 
                this.querySelector(".account-box__left .status").append(document.createElement("br")), 
                this.querySelector(".account-box__left .status").append(chrome.i18n.getMessage("options_logged_in")), 
                this.querySelector(".account-box__left").addEventListener("click", () => {
                    window.open(extConfig.baseUrl + "/account_center", "_blank");
                }), (e = document.createElement("button")).innerText = chrome.i18n.getMessage("options_logout"), 
                e.addEventListener("click", () => {
                    chrome.runtime.sendMessage({
                        action: "logout"
                    }).then(() => {
                        setTimeout(() => {
                            location.reload();
                        }, 500);
                    });
                }), this.querySelector(".account-box__right").append(e)) : (this.querySelector(".account-box").toggleAttribute("login", !1), 
                this.querySelector(".account-box__left .status").append(chrome.i18n.getMessage("options_not_logged_in")), 
                (e = document.createElement("button")).innerText = chrome.i18n.getMessage("options_login"), 
                e.addEventListener("click", () => {
                    var {
                        innerHeight: e,
                        innerWidth: t
                    } = window;
                    let s = !1, a = window.open(chrome.runtime.getURL("popup/login.html"), "_blank", `width=460,height=600, left=${t / 2 - 230}, top=` + (e / 2 - 300)), r = document.createElement("div"), o = (r.classList.add("mask"), 
                    r.style.cssText = `
                            position: fixed;
                            left: 0;
                            top: 0;
                            width: 100vw;
                            height: 100vh;
                            z-index: 99;
                            background-color: rgba(0, 0, 0, .5);
                        `, r.addEventListener("click", () => !s && a.focus()), document.body.appendChild(r), 
                    setInterval(() => {
                        try {
                            s = a.closed;
                        } catch (e) {
                            s = !0;
                        } finally {
                            s && (clearInterval(o), chrome.runtime.sendMessage({
                                action: "getLoginInfo"
                            }).then(e => {
                                e && e.id && location.reload(), r.remove();
                            }));
                        }
                    }, 1e3));
                }), this.querySelector(".account-box__right").append(e));
            }).catch(e => {
                console.log(e);
            });
        }
    }), document.querySelector("#services-template")), r = (a.remove(), customElements.define("services-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            let s = location.hash;
            this.classList.add("panel"), this.append(a.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.runtime.sendMessage({
                action: "getTranslateServiceList"
            }).then(t => {
                var e = t.map(s => {
                    var e = document.createElement("service-card");
                    return e.options = s, e.addEventListener("enabled-change", t => {
                        s.enabled = t.detail.enabled, this.querySelector(`service-card[data-id="${s.id}"]`).toggleAttribute("enabled", t.detail.enabled), 
                        chrome.storage.local.get("translateServices").then(({
                            translateServices: e
                        }) => {
                            e.find(e => e.id === s.id).enabled = t.detail.enabled, 
                            chrome.storage.local.set({
                                translateServices: e
                            });
                        });
                    }), e.addEventListener("default-change", e => {
                        t.forEach(e => e.default = !1), s.default = !0, this.querySelectorAll("service-card").forEach(e => e.removeAttribute("default")), 
                        this.querySelector(`service-card[data-id="${s.id}"]`).toggleAttribute("default", !0), 
                        chrome.storage.local.get("translateServices").then(({
                            translateServices: e
                        }) => {
                            e.forEach(e => e.default = !1), e.find(e => e.id === s.id).default = !0, 
                            chrome.storage.local.set({
                                translateServices: e
                            });
                        });
                    }), e.addEventListener("setting-click", e => {
                        this.renderSettingPanel(s);
                    }), e;
                }), e = (this.querySelector(".services-grid").replaceChildren(...e), 
                this.querySelector(`service-card[data-id="${s.split("/")[1]}"]`));
                e && e.dispatchEvent(new CustomEvent("setting-click", {
                    detail: {
                        id: e.getAttribute("data-id")
                    }
                }));
            });
        }
        renderSettingPanel(e) {
            var t = document.createElement("service-setting-panel");
            t.options = e, document.querySelector("main").replaceChildren(t);
        }
    }), document.querySelector("#service-card-template")), o = (r.remove(), customElements.define("service-card", class extends HTMLElement {
        constructor() {
            super();
        }
        static get observedAttributes() {
            return [ "enabled", "default" ];
        }
        attributeChangedCallback() {
            this.querySelector(".service-card__header-switch input").checked = this.options.enabled, 
            this.querySelector(".service-card__header-switch input").disabled = this.options.default, 
            this.querySelector(".service-card__footer-default").innerText = this.options.default ? chrome.i18n.getMessage("options_default") : chrome.i18n.getMessage("options_set_default");
        }
        connectedCallback() {
            this.classList.add("service-card"), this.append(r.content.cloneNode(!0)), 
            this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.setAttribute("data-id", this.options.id), this.toggleAttribute("enabled", this.options.enabled), 
            this.toggleAttribute("default", this.options.default), this.querySelector(".service-card__header-icon img").src = this.options.icon || "", 
            this.querySelector(".service-card__header-name").innerText = chrome.i18n.getMessage("translate_engine_" + this.options.id) || this.options.name || "", 
            this.querySelector(".service-card__body-desc").replaceChildren(...new DOMParser().parseFromString(chrome.i18n.getMessage("translate_engine_desc_" + this.options.id) || this.options.desc || "", "text/html").body.childNodes), 
            this.querySelector(".service-card__footer-setting").innerText = this.options.config ? chrome.i18n.getMessage("options_setting") : "", 
            this.querySelector(".service-card__header-switch input").addEventListener("change", e => {
                this.dispatchEvent(new CustomEvent("enabled-change", {
                    detail: {
                        id: this.getAttribute("data-id"),
                        enabled: e.target.checked
                    }
                }));
            }), this.querySelector(".service-card__footer-default").addEventListener("click", e => {
                this.dispatchEvent(new CustomEvent("default-change", {
                    detail: {
                        id: this.getAttribute("data-id")
                    }
                }));
            }), this.querySelector(".service-card__footer-setting").addEventListener("click", e => {
                this.dispatchEvent(new CustomEvent("setting-click", {
                    detail: {
                        id: this.getAttribute("data-id")
                    }
                }));
            });
        }
    }), document.querySelector("#service-setting-template")), n = (o.remove(), customElements.define("service-setting-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            let a = this.options;
            var e, t;
            this.classList.add("panel"), this.style.display = "block", this.append(o.content.cloneNode(!0)), 
            this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.querySelectorAll("[data-i18n-html]").forEach(e => {
                var t = chrome.i18n.getMessage(e.dataset.i18nHtml), t = new DOMParser().parseFromString(t, "text/html");
                e.replaceChildren(...t.body.childNodes);
            }), this.options.serverSupport || this.querySelector('.provider-selection__item input[value="TranslateBase"').parentElement.remove(), 
            this.options.extensionSupport || this.querySelector('.provider-selection__item input[value="CustomKey"').parentElement.remove(), 
            this.options.serverSupport && this.options.isPlus && ((e = document.querySelector('.provider-selection__item input[value="TranslateBase"').nextElementSibling.querySelector(".provider-selection__item-desc")).removeAttribute("data-i18n"), 
            t = chrome.i18n.getMessage("options_translatebase_plus_desc"), t = new DOMParser().parseFromString(t, "text/html"), 
            e.replaceChildren(...t.body.childNodes), e.querySelector("a").addEventListener("click", e => {
                e.stopPropagation(), chrome.storage.local.get("baseUrl").then(({
                    baseUrl: e
                }) => {
                    window.open(e + "/subscribe");
                });
            })), this.querySelector(".panel__header-title").innerText = a.name || "", 
            this.querySelector(`.provider-selection__item input[value="${a.config.provider}"`).checked = !0, 
            this.querySelector(".custom-key input").value = a.config.apiKey || "", 
            this.querySelector(".custom-key").style.display = "CustomKey" === a.config.provider ? "block" : "none", 
            this.querySelector(".request-text-length__input").value = a.config.requestTextLen, 
            this.querySelector(".request-paragraphs__input").value = a.config.requestParagraphs, 
            this.querySelector(".panel__header-title").addEventListener("click", () => {
                var e = document.createElement("services-panel");
                document.querySelector("main").replaceChildren(e);
            }), this.querySelector(".panel__header-right .test-btn").addEventListener("click", t => {
                if ("CustomKey" !== a.config.provider || a.config.apiKey) {
                    let e = t.target.closest(".test-btn");
                    e.disabled = !0, e.classList.add("loading"), chrome.runtime.sendMessage({
                        action: "translateText",
                        data: {
                            server: a.id,
                            textArr: [ "Hello, TranslateBase" ],
                            options: {
                                from: "en",
                                fromLangId: "70",
                                to: "zh",
                                toLangId: "59"
                            }
                        }
                    }).then(e => {
                        200 === e.code ? this.toast(chrome.i18n.getMessage("options_translate_success")) : this.toast(chrome.i18n.getMessage("options_translate_fail") + e.message);
                    }).catch(e => {
                        console.log("Test error:", e);
                    }).finally(() => {
                        e.disabled = !1, e.classList.remove("loading");
                    });
                } else this.toast(chrome.i18n.getMessage("options_api_key_required"));
            }), this.querySelectorAll(".provider-selection__item input").forEach(e => {
                e.addEventListener("change", s => {
                    chrome.storage.local.get("translateServices").then(({
                        translateServices: e
                    }) => {
                        var t = e.find(e => e.id === a.id);
                        t.config.provider = s.target.value, Object.assign(a, t), 
                        chrome.storage.local.set({
                            translateServices: e
                        });
                    }), this.querySelector(".custom-key").style.display = "CustomKey" === s.target.value ? "block" : "none";
                });
            });
            let r = null;
            this.querySelector(".custom-key input").addEventListener("input", s => {
                s.target.value = s.target.value.trim(), r && clearTimeout(r), r = setTimeout(() => {
                    chrome.storage.local.get("translateServices").then(({
                        translateServices: e
                    }) => {
                        var t = e.find(e => e.id === a.id);
                        t.config.apiKey = s.target.value, Object.assign(a, t), chrome.storage.local.set({
                            translateServices: e
                        }).then(() => {
                            this.toast(chrome.i18n.getMessage("options_save_success"));
                        });
                    });
                }, 500);
            }), this.querySelector(".request-text-length__input").addEventListener("change", e => {
                let s = parseInt(e.target.value);
                isNaN(s) || s < parseInt(e.target.min) ? s = parseInt(e.target.min) : s > parseInt(e.target.max) && (s = parseInt(e.target.max)), 
                e.target.value = s, chrome.storage.local.get("translateServices").then(({
                    translateServices: e
                }) => {
                    var t = e.find(e => e.id === a.id);
                    t.config.requestTextLen = s, Object.assign(a, t), chrome.storage.local.set({
                        translateServices: e
                    });
                });
            }), this.querySelector(".request-paragraphs__input").addEventListener("change", e => {
                let s = parseInt(e.target.value);
                isNaN(s) || s < parseInt(e.target.min) ? s = parseInt(e.target.min) : s > parseInt(e.target.max) && (s = parseInt(e.target.max)), 
                e.target.value = s, chrome.storage.local.get("translateServices").then(({
                    translateServices: e
                }) => {
                    var t = e.find(e => e.id === a.id);
                    t.config.requestParagraphs = s, Object.assign(a, t), chrome.storage.local.set({
                        translateServices: e
                    });
                });
            }), this.querySelector(".reset-btn").addEventListener("click", () => {
                chrome.storage.local.get("translateServices").then(({
                    translateServices: e
                }) => {
                    let t = e.find(e => e.id === a.id);
                    t.config.provider = t.serverSupport ? "TranslateBase" : "CustomKey", 
                    t.config.apiKey = "", t.config.requestTextLen = t.config.defaultRequestTextLen, 
                    t.config.requestParagraphs = t.config.defaultRequestParagraphs, 
                    Object.assign(a, t), chrome.storage.local.set({
                        translateServices: e
                    }).then(() => {
                        var e = document.createElement("service-setting-panel");
                        e.options = t, document.querySelector("main").replaceChildren(e);
                    });
                });
            });
        }
        toast(e, t = "info") {
            this.toastTimer && (clearTimeout(this.toastTimer), this.globalToast.remove()), 
            this.globalToast || (this.globalToast = document.createElement("div"), 
            this.globalToast.classList.add("toast", t), this.globalToast.style.cssText = `
                    position: absolute;
                    top: 0px;
                    left: 50%;
                    transform: translateX(-50%);
                    padding: 0.5rem 1rem;
                    border-radius: 0.25rem;
                    background: #edf2fc;
                    font-size: 1rem;
                    color: #909399;
                `), this.globalToast.innerText = e, this.appendChild(this.globalToast), 
            this.toastTimer = setTimeout(() => {
                this.globalToast.remove();
            }, 3e3), this.globalToast.addEventListener("mouseenter", () => {
                clearTimeout(this.toastTimer);
            }), this.globalToast.addEventListener("mouseleave", () => {
                this.toastTimer = setTimeout(() => {
                    this.globalToast.remove();
                }, 3e3);
            });
        }
    }), document.querySelector("#chat-template")), i = (n.remove(), customElements.define("chat-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(n.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.storage.local.get([ "difyAiArr" ]).then(({
                difyAiArr: e
            }) => {
                e = e.reduce((e, t) => (e.push(new Option(t.modelName, t.id, !1, t.default)), 
                e), []);
                this.querySelector('select[data-type="chatAiModel"]').append(...e), 
                this.querySelector('select[data-type="chatAiModel"]').addEventListener("change", t => {
                    chrome.storage.local.get("difyAiArr").then(({
                        difyAiArr: e
                    }) => {
                        e.forEach(e => e.default = !1), e.find(e => e.id === t.target.value).default = !0, 
                        chrome.storage.local.set({
                            difyAiArr: e
                        });
                    });
                });
            });
        }
    }), document.querySelector("#floating-template")), l = (i.remove(), customElements.define("floating-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(i.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.storage.local.get("sidebarPopupConfig").then(({
                sidebarPopupConfig: s
            }) => {
                this.querySelector('.switch [data-type="floatingEnabled"]').checked = s.enable, 
                this.querySelector('.switch [data-type="floatingEnabled"]').addEventListener("change", t => {
                    chrome.storage.local.get("sidebarPopupConfig").then(e => {
                        e.sidebarPopupConfig.enable = t.target.checked, Object.assign(s, e.sidebarPopupConfig), 
                        chrome.storage.local.set({
                            sidebarPopupConfig: e.sidebarPopupConfig
                        });
                    });
                });
                var e = [ "left", "right", "top", "bottom" ].map(e => new Option(chrome.i18n.getMessage("options_floating_potions_" + e), e, !1, e === s.position));
                this.querySelector('.select[data-type="floatingPosition"]').replaceChildren(...e), 
                this.querySelector('.select[data-type="floatingPosition"]').addEventListener("change", t => {
                    chrome.storage.local.get("sidebarPopupConfig").then(e => {
                        e.sidebarPopupConfig.position = t.target.value, e.sidebarPopupConfig.inset = [ null, null, null, null ], 
                        Object.assign(s, e.sidebarPopupConfig), chrome.storage.local.set({
                            sidebarPopupConfig: e.sidebarPopupConfig
                        });
                    });
                }), this.querySelector(".background-color-picker").value = s.bgColor, 
                this.querySelector(".background-color-picker").addEventListener("input", t => {
                    chrome.storage.local.get("sidebarPopupConfig").then(e => {
                        e.sidebarPopupConfig.bgColor = t.target.value, Object.assign(s, e.sidebarPopupConfig), 
                        chrome.storage.local.set({
                            sidebarPopupConfig: e.sidebarPopupConfig
                        });
                    });
                }), this.querySelector(".range-picker__input").value = s.bgOpacity, 
                this.querySelector(".range-picker__value").innerText = (100 * s.bgOpacity).toFixed(0) + "%", 
                this.querySelector(".range-picker__input").addEventListener("input", t => {
                    this.querySelector(".range-picker__value").innerText = (100 * t.target.value).toFixed(0) + "%", 
                    chrome.storage.local.get("sidebarPopupConfig").then(e => {
                        e.sidebarPopupConfig.bgOpacity = t.target.value, Object.assign(s, e.sidebarPopupConfig), 
                        chrome.storage.local.set({
                            sidebarPopupConfig: e.sidebarPopupConfig
                        });
                    });
                }), this.renderCustomList(s.disabledWebsites), this.querySelector(".add-btn").addEventListener("click", () => {
                    var e = document.createElement("floating-custom-win");
                    e.url = "", e.addEventListener("confirm", t => {
                        chrome.storage.local.get("sidebarPopupConfig").then(e => {
                            e.sidebarPopupConfig.disabledWebsites = [ ...new Set(e.sidebarPopupConfig.disabledWebsites.concat(t.detail.value)) ], 
                            Object.assign(s, e.sidebarPopupConfig), chrome.storage.local.set({
                                sidebarPopupConfig: e.sidebarPopupConfig
                            }), this.renderCustomList(s.disabledWebsites);
                        });
                    }), document.body.appendChild(e);
                }), this.querySelector('.custom-list__toolbar input[type="checkbox"]').addEventListener("click", t => {
                    this.querySelectorAll('.custom-list__content input[type="checkbox"]').forEach(e => {
                        e.checked = t.target.checked;
                    });
                }), this.querySelector(".custom-list__toolbar .delete-btn").addEventListener("click", e => {
                    let t = Array.from(this.querySelectorAll(".custom-list__content input:not(:checked)")).map(e => e.parentElement.querySelector(".website").innerText);
                    chrome.storage.local.get("sidebarPopupConfig").then(e => {
                        e.sidebarPopupConfig.disabledWebsites = t, Object.assign(s, e.sidebarPopupConfig), 
                        chrome.storage.local.set({
                            sidebarPopupConfig: e.sidebarPopupConfig
                        }), this.renderCustomList(s.disabledWebsites);
                    });
                });
            });
        }
        renderCustomList(e) {
            e.length ? (this.querySelector(".custom-list").classList.remove("hidden"), 
            this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = !1, 
            e = e.map(a => {
                var e = `
                    <label class="row flex flex-between">
                        <input type="checkbox">
                        <span class="website">${a}</span>
                        <div class="toolbar flex">
                        <div class="edit-btn">${chrome.i18n.getMessage("options_edit")}</div>
                        <div class="delete-btn">${chrome.i18n.getMessage("options_delete")}</div>
                        </div>
                    </label>
                `, e = new DOMParser().parseFromString(e, "text/html").body.firstChild;
                return e.querySelector('input[type="checkbox"]').addEventListener("change", e => {
                    e.preventDefault();
                    e = 0 === this.querySelectorAll(".custom-list__content input:not(:checked)").length;
                    this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = e;
                }), e.querySelector(".edit-btn").addEventListener("click", e => {
                    e.preventDefault();
                    e = document.createElement("floating-custom-win");
                    e.url = a, e.addEventListener("confirm", s => {
                        chrome.storage.local.get("sidebarPopupConfig").then(({
                            sidebarPopupConfig: e
                        }) => {
                            var t = e.disabledWebsites;
                            t.splice(t.indexOf(a), 1, s.detail.value), chrome.storage.local.set({
                                sidebarPopupConfig: e
                            }), this.renderCustomList(e.disabledWebsites);
                        });
                    }), document.body.appendChild(e);
                }), e.querySelector(".delete-btn").addEventListener("click", e => {
                    e.preventDefault(), chrome.storage.local.get("sidebarPopupConfig").then(({
                        sidebarPopupConfig: e
                    }) => {
                        e.disabledWebsites = e.disabledWebsites.filter(e => e !== a), 
                        chrome.storage.local.set({
                            sidebarPopupConfig: e
                        }), this.renderCustomList(e.disabledWebsites);
                    });
                }), e;
            }), this.querySelector(".custom-list__content").replaceChildren(...e)) : this.querySelector(".custom-list").classList.add("hidden");
        }
    }), document.querySelector("#floating-custom-win-template")), c = (l.remove(), 
    customElements.define("floating-custom-win", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("win__wrapper"), this.append(l.content.cloneNode(!0)), 
            this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.querySelector(".website-input").value = this.url, this.querySelector(".website-input").addEventListener("input", e => {
                e.target.value = e.target.value.trim();
            }), this.querySelector(".btn-cancel").addEventListener("click", e => {
                this.remove();
            }), this.querySelector(".btn-confirm").addEventListener("click", e => {
                this.querySelector(".website-input").value && (this.dispatchEvent(new CustomEvent("confirm", {
                    detail: {
                        value: this.querySelector(".website-input").value
                    }
                })), this.remove());
            });
        }
    }), document.querySelector("#translate-template")), d = (c.remove(), customElements.define("translate-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(c.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.storage.local.get("webTranslationConfig").then(({
                webTranslationConfig: r
            }) => {
                this.querySelector('.select[data-type="showMode"]').value = r.translationMode, 
                this.querySelector('.select[data-type="showMode"]').addEventListener("change", t => {
                    chrome.storage.local.get("webTranslationConfig").then(e => {
                        e.webTranslationConfig.translationMode = t.target.value, 
                        Object.assign(r, e.webTranslationConfig), chrome.storage.local.set({
                            webTranslationConfig: r
                        });
                    });
                });
                var e = this.querySelector('.select[data-type="translationColorType"]');
                let s = this.querySelector(".translation-color__picker");
                e.value = r.translationColorType, s.value = r.translationColor, 
                s.classList.toggle("hidden", "inherit" === r.translationColorType), 
                e.addEventListener("change", t => {
                    s.classList.toggle("hidden", "inherit" === t.target.value), 
                    chrome.storage.local.get("webTranslationConfig").then(e => {
                        e.webTranslationConfig.translationColorType = t.target.value, 
                        Object.assign(r, e.webTranslationConfig), chrome.storage.local.set({
                            webTranslationConfig: r
                        });
                    });
                }), s.addEventListener("input", t => {
                    chrome.storage.local.get("webTranslationConfig").then(e => {
                        e.webTranslationConfig.translationColor = t.target.value, 
                        Object.assign(r, e.webTranslationConfig), chrome.storage.local.set({
                            webTranslationConfig: r
                        });
                    });
                }), this.renderCustomList(r.customWebsite), this.querySelector(".add-btn").addEventListener("click", () => {
                    var e = document.createElement("translate-custom-win");
                    e.options = {
                        url: "",
                        ...structuredClone(r)
                    }, e.addEventListener("confirm", a => {
                        chrome.storage.local.get("webTranslationConfig").then(e => {
                            let {
                                url: t,
                                ...s
                            } = a.detail;
                            e.webTranslationConfig.customWebsite[t] = s, Object.assign(r, e.webTranslationConfig), 
                            chrome.storage.local.set({
                                webTranslationConfig: e.webTranslationConfig
                            }), this.renderCustomList(r.customWebsite);
                        });
                    }), document.body.appendChild(e);
                }), this.querySelector('.custom-list__toolbar input[type="checkbox"]').addEventListener("click", t => {
                    this.querySelectorAll('.custom-list__content input[type="checkbox"]').forEach(e => {
                        e.checked = t.target.checked;
                    });
                }), this.querySelector(".custom-list__toolbar .delete-btn").addEventListener("click", e => {
                    let s = Array.from(this.querySelectorAll(".custom-list__content input:checked")).map(e => e.parentElement.querySelector(".website").innerText);
                    chrome.storage.local.get("webTranslationConfig").then(t => {
                        s.forEach(e => {
                            delete t.webTranslationConfig.customWebsite[e];
                        }), Object.assign(r, t.webTranslationConfig), chrome.storage.local.set({
                            webTranslationConfig: t.webTranslationConfig
                        }), this.renderCustomList(r.customWebsite);
                    });
                });
            });
        }
        renderCustomList(e) {
            var e = Object.keys(e) || [];
            e.length ? (this.querySelector(".custom-list").classList.remove("hidden"), 
            this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = !1, 
            e = e.map(r => {
                var e = `
                    <label class="row flex flex-between">
                        <input type="checkbox">
                        <span class="website">${r}</span>
                        <div class="toolbar flex">
                        <div class="edit-btn">${chrome.i18n.getMessage("options_edit")}</div>
                        <div class="delete-btn">${chrome.i18n.getMessage("options_delete")}</div>
                        </div>
                    </label>
                `, e = new DOMParser().parseFromString(e, "text/html").body.firstChild;
                return e.querySelector('input[type="checkbox"]').addEventListener("change", e => {
                    e.preventDefault();
                    e = 0 === this.querySelectorAll(".custom-list__content input:not(:checked)").length;
                    this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = e;
                }), e.querySelector(".edit-btn").addEventListener("click", e => {
                    e.preventDefault(), chrome.storage.local.get("webTranslationConfig").then(({
                        webTranslationConfig: a
                    }) => {
                        var e = document.createElement("translate-custom-win");
                        e.options = {
                            url: r,
                            ...structuredClone(a.customWebsite[r])
                        }, e.addEventListener("confirm", e => {
                            let {
                                url: t,
                                ...s
                            } = e.detail;
                            r !== t && delete a.customWebsite[r], a.customWebsite[t] = s, 
                            chrome.storage.local.set({
                                webTranslationConfig: a
                            }), this.renderCustomList(a.customWebsite);
                        }), document.body.appendChild(e);
                    });
                }), e.querySelector(".delete-btn").addEventListener("click", e => {
                    e.preventDefault(), chrome.storage.local.get("webTranslationConfig").then(({
                        webTranslationConfig: e
                    }) => {
                        delete e.customWebsite[r], chrome.storage.local.set({
                            webTranslationConfig: e
                        }), this.renderCustomList(e.customWebsite);
                    });
                }), e;
            }), this.querySelector(".custom-list__content").replaceChildren(...e)) : this.querySelector(".custom-list").classList.add("hidden");
        }
    }), document.querySelector("#translate-custom-win-template")), u = (d.remove(), 
    customElements.define("translate-custom-win", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("win__wrapper"), this.append(d.content.cloneNode(!0)), 
            this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.querySelector(".website-input").value = this.options.url, this.querySelector(".website-input").addEventListener("input", e => {
                e.target.value = e.target.value.trim();
            }), this.querySelector('.select[data-type="showMode"]').value = this.options.translationMode;
            let t = this.querySelector('.select[data-type="translationColorType"]'), s = this.querySelector(".translation-color__picker");
            t.value = this.options.translationColorType, s.value = this.options.translationColor, 
            s.classList.toggle("hidden", "inherit" === this.options.translationColorType), 
            t.addEventListener("change", e => {
                s.classList.toggle("hidden", "inherit" === e.target.value);
            }), this.querySelector(".btn-cancel").addEventListener("click", e => {
                this.remove();
            }), this.querySelector(".btn-confirm").addEventListener("click", e => {
                this.querySelector(".website-input").value && (this.dispatchEvent(new CustomEvent("confirm", {
                    detail: {
                        url: this.querySelector(".website-input").value,
                        translationMode: this.querySelector('.select[data-type="showMode"]').value,
                        translationColorType: t.value,
                        translationColor: s.value
                    }
                })), this.remove());
            });
        }
    }), document.querySelector("#subtitle-template")), h = (u.remove(), customElements.define("subtitle-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(u.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.storage.local.get("subtitleTranslationConfig").then(({
                subtitleTranslationConfig: r
            }) => {
                this.querySelector('.select[data-type="showMode"]').value = r.showMode, 
                this.querySelector('.select[data-type="showMode"]').addEventListener("change", t => {
                    chrome.storage.local.get("subtitleTranslationConfig").then(e => {
                        e.subtitleTranslationConfig.showMode = t.target.value, Object.assign(r, e.subtitleTranslationConfig), 
                        chrome.storage.local.set({
                            subtitleTranslationConfig: r
                        });
                    });
                }), this.querySelector('.select[data-type="translationPosition"]').value = r.position, 
                this.querySelector('.select[data-type="translationPosition"]').addEventListener("change", async t => {
                    chrome.storage.local.get("subtitleTranslationConfig").then(e => {
                        e.subtitleTranslationConfig.position = t.target.value, Object.assign(r, e.subtitleTranslationConfig), 
                        chrome.storage.local.set({
                            subtitleTranslationConfig: r
                        });
                    });
                }), this.renderCustomList(r.customWebsite), this.querySelector(".add-btn").addEventListener("click", () => {
                    var e = document.createElement("subtitle-custom-win");
                    e.options = {
                        url: "",
                        ...structuredClone(r)
                    }, e.addEventListener("confirm", a => {
                        chrome.storage.local.get("subtitleTranslationConfig").then(e => {
                            let {
                                url: t,
                                ...s
                            } = a.detail;
                            e.subtitleTranslationConfig.customWebsite[t] = s, Object.assign(r, e.subtitleTranslationConfig), 
                            chrome.storage.local.set({
                                subtitleTranslationConfig: e.subtitleTranslationConfig
                            }), this.renderCustomList(r.customWebsite);
                        });
                    }), document.body.appendChild(e);
                }), this.querySelector('.custom-list__toolbar input[type="checkbox"]').addEventListener("click", t => {
                    this.querySelectorAll('.custom-list__content input[type="checkbox"]').forEach(e => {
                        e.checked = t.target.checked;
                    });
                }), this.querySelector(".custom-list__toolbar .delete-btn").addEventListener("click", e => {
                    let s = Array.from(this.querySelectorAll(".custom-list__content input:checked")).map(e => e.parentElement.querySelector(".website").innerText);
                    chrome.storage.local.get("subtitleTranslationConfig").then(t => {
                        s.forEach(e => {
                            delete t.subtitleTranslationConfig.customWebsite[e];
                        }), Object.assign(r, t.subtitleTranslationConfig), chrome.storage.local.set({
                            subtitleTranslationConfig: t.subtitleTranslationConfig
                        }), this.renderCustomList(r.customWebsite);
                    });
                });
            });
        }
        renderCustomList(e) {
            var e = Object.keys(e) || [];
            e.length ? (this.querySelector(".custom-list").classList.remove("hidden"), 
            this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = !1, 
            e = e.map(r => {
                var e = `
                    <label class="row flex flex-between">
                        <input type="checkbox">
                        <span class="website">${r}</span>
                        <div class="toolbar flex">
                        <div class="edit-btn">${chrome.i18n.getMessage("options_edit")}</div>
                        <div class="delete-btn">${chrome.i18n.getMessage("options_delete")}</div>
                        </div>
                    </label>
                `, e = new DOMParser().parseFromString(e, "text/html").body.firstChild;
                return e.querySelector('input[type="checkbox"]').addEventListener("change", e => {
                    e.preventDefault();
                    e = 0 === this.querySelectorAll(".custom-list__content input:not(:checked)").length;
                    this.querySelector('.custom-list__toolbar input[type="checkbox"]').checked = e;
                }), e.querySelector(".edit-btn").addEventListener("click", e => {
                    e.preventDefault(), chrome.storage.local.get("subtitleTranslationConfig").then(({
                        subtitleTranslationConfig: a
                    }) => {
                        var e = document.createElement("subtitle-custom-win");
                        e.options = {
                            url: r,
                            ...structuredClone(a.customWebsite[r])
                        }, e.addEventListener("confirm", e => {
                            let {
                                url: t,
                                ...s
                            } = e.detail;
                            r !== t && delete a.customWebsite[r], delete s.enabled, 
                            a.customWebsite[t] = s, chrome.storage.local.set({
                                subtitleTranslationConfig: a
                            }), this.renderCustomList(a.customWebsite);
                        }), document.body.appendChild(e);
                    });
                }), e.querySelector(".delete-btn").addEventListener("click", e => {
                    e.preventDefault(), chrome.storage.local.get("subtitleTranslationConfig").then(({
                        subtitleTranslationConfig: e
                    }) => {
                        delete e.customWebsite[r], chrome.storage.local.set({
                            subtitleTranslationConfig: e
                        }), this.renderCustomList(e.customWebsite);
                    });
                }), e;
            }), this.querySelector(".custom-list__content").replaceChildren(...e)) : this.querySelector(".custom-list").classList.add("hidden");
        }
    }), document.querySelector("#subtitle-custom-win-template")), g = (h.remove(), 
    customElements.define("subtitle-custom-win", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("win__wrapper"), this.append(h.content.cloneNode(!0)), 
            this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), this.querySelector(".website-input").value = this.options.url, this.querySelector(".website-input").addEventListener("input", e => {
                e.target.value = e.target.value.trim();
            }), this.querySelector('.select[data-type="showMode"]').value = this.options.showMode, 
            this.querySelector('.select[data-type="translationPosition"]').value = this.options.position, 
            this.querySelector(".btn-cancel").addEventListener("click", e => {
                this.remove();
            }), this.querySelector(".btn-confirm").addEventListener("click", e => {
                this.querySelector(".website-input").value && (this.dispatchEvent(new CustomEvent("confirm", {
                    detail: {
                        url: this.querySelector(".website-input").value,
                        showMode: this.querySelector('.select[data-type="showMode"]').value,
                        position: this.querySelector('.select[data-type="translationPosition"]').value
                    }
                })), this.remove());
            });
        }
    }), document.querySelector("#extract-words-template"));
    g.remove(), customElements.define("extract-words-panel", class extends HTMLElement {
        constructor() {
            super();
        }
        connectedCallback() {
            this.classList.add("panel"), this.append(g.content.cloneNode(!0)), this.querySelectorAll("[data-i18n]").forEach(e => {
                e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
            }), chrome.storage.local.get("extractWordsConfig").then(({
                extractWordsConfig: s
            }) => {
                this.querySelector('.select[data-type="extractWordsPosition"]').value = s.position, 
                this.querySelector('.select[data-type="extractWordsPosition"]').addEventListener("change", t => {
                    chrome.storage.local.get("extractWordsConfig").then(e => {
                        e.extractWordsConfig.position = t.target.value, Object.assign(s, e.extractWordsConfig), 
                        chrome.storage.local.set({
                            extractWordsConfig: s
                        });
                    });
                }), this.querySelector('.select[data-type="extractWordsService"]').addEventListener("change", async t => {
                    chrome.storage.local.get("extractWordsConfig").then(e => {
                        e.extractWordsConfig.service = t.target.value, Object.assign(s, e.extractWordsConfig), 
                        chrome.storage.local.set({
                            extractWordsConfig: s
                        });
                    });
                });
                var e = new Array(20).fill(0).map((e, t) => new Option(t + 1, t + 1));
                this.querySelector('.select[data-type="extractWordsCount"]').replaceChildren(...e), 
                this.querySelector('.select[data-type="extractWordsCount"]').value = s.extractWordNum, 
                this.querySelector('.select[data-type="extractWordsCount"]').addEventListener("change", async t => {
                    chrome.storage.local.get("extractWordsConfig").then(e => {
                        e.extractWordsConfig.extractWordNum = t.target.value, Object.assign(s, e.extractWordsConfig), 
                        chrome.storage.local.set({
                            extractWordsConfig: s
                        });
                    });
                });
            });
        }
    }), document.addEventListener("DOMContentLoaded", function() {
        document.querySelectorAll("[data-i18n]").forEach(e => {
            e.innerText = chrome.i18n.getMessage(e.dataset.i18n);
        }), document.querySelectorAll("aside a.nav-item").forEach((e, t, o) => {
            e.addEventListener("click", e => {
                var e = e.target.closest(".nav-item"), t = e.parentNode, s = e.getBoundingClientRect(), a = t.getBoundingClientRect();
                if (t.scrollTo({
                    left: s.left - a.left + t.scrollLeft - (a.width / 2 - s.width / 2),
                    behavior: "smooth"
                }), !e.hasAttribute("active")) switch (o.forEach(e => e.removeAttribute("active")), 
                e.toggleAttribute("active", !0), e.getAttribute("href")) {
                  case "#base":
                    var r = document.createElement("base-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#services":
                    r = document.createElement("services-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#chat":
                    r = document.createElement("chat-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#floating":
                    r = document.createElement("floating-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#translate":
                    r = document.createElement("translate-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#subtitle":
                    r = document.createElement("subtitle-panel");
                    document.querySelector("main").replaceChildren(r);
                    break;

                  case "#extractWords":
                    r = document.createElement("extract-words-panel");
                    document.querySelector("main").replaceChildren(r);
                }
            });
        }), document.querySelector(`aside a.nav-item[href="${location.hash?.split("/")[0] || "#base"}"]`).click(), 
        document.querySelector("header .logo").addEventListener("click", () => {
            window.open(extConfig.baseUrl, "_blank");
        }), e.then(e => {
            var t;
            e && "1" === e.isGiveAway && Date.now() < new Date(e.subscriptionExpiryDate) && (e = new Date(e.subscriptionExpiryDate) - Date.now(), 
            e = Math.ceil(e / 864e5), (t = document.createElement("div")).classList.add("free-trial-subtitles"), 
            e = new DOMParser().parseFromString(chrome.i18n.getMessage("options_free_trial", [ e, extConfig.baseUrl ]), "text/html"), 
            t.append(...e.body.childNodes), t.style.cssText = `
                    position: fixed;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 2.25rem;
                    padding: 0 1rem;
                    z-index: 98;
                    background: #fdf6ec;
                    font-size: 1rem;
                    color: #000;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                `, t.querySelector("a").style.cssText = `
                    color: inherit;
                    text-decoration: underline;
                `, document.body.prepend(t), document.body.toggleAttribute("notice", !0));
        }).catch(e => {
            console.log(e);
        });
    });
})();